



import java.io.*;
import java.util.*;

/*

According to the assignment#1 we are required to create a class to represent polynomials of the 
following form:
  anxn + . . . a2x2 + a1x + a0  where maximum degree is 5.

The program is a simple one. I used the algorithm from the assignment requirement for addition, 
subtraction and multiplication by constant. My program was designed to enable mathematical operations 
of two polynomials with different degrees, i.e. up to 5. It can also check the result of mathematical 
operations and return the appropriate polynomial. The whole  program is composed of two classes: class 
Polynomial and class testPolynomial.

*/

public class Polynomial {
  double coefficient[]; 
  int     degree;
  static int maxdeg=5;

  //get cofficients of polinomial and initialize them. Assign degree to the
  // most highest cofficient which is not zero
  public Polynomial(double incof[]) 
  {
    int d=0;
    coefficient = new double[maxdeg+1];
    for(int k=0;k<incof.length;k++){
      coefficient[k] = incof[k];
      if (incof[k] != 0)
	d = k;
    }
    degree = d;
  }

  //initializa polinomial to zeros
  public Polynomial() 
  {
    coefficient = new double[maxdeg+1];
    for(int k=0;k<maxdeg+1;k++)
      coefficient[k] = 0.0;
    degree = 0;

  }
  // return the degree of the polynomial
  public int getDegree()        // return the degree of the polynomial
  {
    return degree;
  }
  // return the Coefficients  of the polynomial
  public  double[] getCoefficient() 
  {
    return coefficient;
  }


  // print the polynomial on the command line
  public  String ToString()          
  {
    String pols="";
    for(int k=degree;k>0;k--)
      pols += coefficient[k]+"x**"+k+ " + ";
    pols += coefficient[0];
    return pols;
  }

  //read polinomial degree and cofficients put them into its class fields
  public   static Polynomial readPolCof() 
  {
    
    double []incof = new double[maxdeg+1];
    //DataInputStream dis = new DataInputStream(System.in);
    BufferedReader dis = new BufferedReader(new InputStreamReader(System.in));

    System.out.print("Enter Polynomial degree:");
    try{
      //int indeg = dis.readInt();
      
      String sdeg = dis.readLine();
      int indeg = Integer.parseInt(sdeg);
      System.out.println("");
      for(int k=indeg;k>=0;k--){
	System.out.print("Enter coefficient["+k+"]:");

	String scof = dis.readLine();
	incof[k] = Double.parseDouble(scof);
	//incof[k] = dis.readDouble();
      }
    }catch(IOException ioexc){System.out.println("Excp:"+ioexc);}
    Polynomial pol = new Polynomial(incof);
    return pol;
  }

  //perform addition
  public  Polynomial addPol(Polynomial A)      //perform addition
  {
    double []Acof = A.getCoefficient();          //read coeeficients
    double []Bcof = getCoefficient(); 
    
    int maxDegree = getMax(A.getDegree(), getDegree());

    double []Ccof = new double[maxdeg+1];
    for(int k=0;k<=maxDegree;k++) {
      Ccof[k] =0;
      try {Ccof[k] += Acof[k];             //degree of the polynomials may be different
      } catch (Exception e){}              //
      try {Ccof[k] += Bcof[k];
      } catch (Exception e){}
    }
    Polynomial pol = new Polynomial(Ccof);
    return pol;
  }

  public  int getMax(int a, int b)    //for returning max degree
  {
    int m = 0;
    if (a > b)
      m = a;
    else
      m = b;
    return m;
  }
  //perform subtraction
  public  Polynomial subPol(Polynomial B)  
  {
    double []Acof = getCoefficient();
    double []Bcof = B.getCoefficient(); //read coeeficients
    int maxDegree = getMax(getDegree(), B.getDegree());

    double []Ccof = new double[maxdeg+1];
    for(int k=0;k<=maxDegree;k++)
      {
	Ccof[k] =0;
	try {Ccof[k] += Acof[k];//degree of the polynomials may be different
	} catch (Exception e){}
	try {Ccof[k] -= Bcof[k];
	} catch (Exception e){}
      }

    Polynomial pol = new Polynomial(Ccof);
    return pol;
  }
  //perform multiplication with constant
  public  Polynomial multPol(double constant)
  {
    double []Acof = getCoefficient();
    double []Ccof = new double[maxdeg+1];
    for(int k=0;k<maxdeg+1;k++)
      Ccof[k] = Acof[k]*constant;
    Polynomial pol = new Polynomial(Ccof);
    return pol;
  }
}

