
import java.io.*;
import java.util.*;
/*


    Test class prompts user for inputs. Test class interprets the user inputs to perform polynomial 
operations. Based on given operation it calls the Polynomial object methods. The followings are basic 
operations test class support;

R(X): Read polynomial called X and make an instance of polynomial class. Then calls readPolCof 
method of the instance object.
X+Y: Perform additions of two polynomials called X and Y respectively. The result printed on the 
screen.
X-Y:  Perform subtraction of two polynomials called X and Y respectively. The result printed on the 
screen.
c*X : Perform constant multiplication with polynomial X.
val(X): Print the polynomial X on the screen.

q or Q: Exit
*/
public class test {
static Hashtable polynomials;

//parse user inputs and call related polynomial methods
public static void parseInput(String input)
  {
    //Read a polinomial X with R(X)
    if ((input.indexOf("R") == 0)&&(input.indexOf("(") == 1)){
      String polName = input.substring(2, input.indexOf(")"));
      Polynomial polVal = Polynomial.readPolCof();  //read  coefficients
      polynomials.put(polName, polVal);                  // put into hashtable
      System.out.println("Result :"+polVal.ToString());
    }
    //X+Y
    else if (input.indexOf("+") >0){      // check whether + operation, i.e., + sign 
      int plus = input.indexOf("+");                 
      String firstPolName = input.substring(0,plus);
      String secondPolName = input.substring(plus+1);
      System.out.println("Pols :"+firstPolName+" and "+secondPolName);
      Polynomial A = (Polynomial)polynomials.get(firstPolName); //get stored polynomial objects from Hashtble
      Polynomial B = (Polynomial)polynomials.get(secondPolName);
      Polynomial resPol = A.addPol(B);            
      System.out.println("Result :"+resPol.ToString());
    }
      //X-Y
    else if (input.indexOf("-") >0){  // check whether - operation, i.e., - sign 
      int minus = input.indexOf("-");
      String firstPolName = input.substring(0,minus);
      String secondPolName = input.substring(minus+1);
      Polynomial A = (Polynomial)polynomials.get(firstPolName);
      Polynomial B = (Polynomial)polynomials.get(secondPolName);//get stored polynomial objects from Hashtble
      Polynomial resPol = A.subPol(B);
      System.out.println("Result :"+resPol.ToString());
    }
	//c*X
    else if (input.indexOf("*") > 0){// check whether * operation, i.e., * sign 
      int star = input.indexOf("*");
      double constant = Double.parseDouble(input.substring(0,star));
      Polynomial A = (Polynomial)polynomials.get(input.substring(star+1));//get stored polynomial objects from Hashtble
      Polynomial resPol = A.multPol(constant);
      System.out.println("Result :"+resPol.ToString());
    }
//val(X): value of the polynomial
    else if (input.indexOf("val(") >=0){ //print the polynomial to screen 
      int closingParanthesis = input.indexOf(")");
      String polName = input.substring(4, closingParanthesis);
      Polynomial resPol = (Polynomial)polynomials.get(polName);
      System.out.println("Result :"+resPol.ToString());        //converts polynomial to a string
    }
	// q,Q: quits
    else if (input.equals("q")||input.equals("Q")){ //quit
      System.out.println("Thank you, bye!");
      System.exit(1);
    }
  }


public static void main(String []args)
  {
    boolean flag=false;
    polynomials= new Hashtable();


    System.out.println("Type R(X) to read, X+Y and X-Y to add and substract");
    System.out.println("Type c*X to multiply X with c and val(X) to print X");
    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    //reads from command line

    while(!flag){
      try{
	System.out.print("Command> ");   // print command line
	String input = br.readLine();    // read input
	parseInput(input);               // process command
      }catch(Exception ioexc){
	ioexc.printStackTrace();
	System.out.println("ERROR in INPUT, please try again and be careful\n:"+ioexc);}
    }
    
    
  }


}
