// File:  Penalty.java



import java.applet.Applet;  //applet class
//import java.awt.*; to show used components 
import java.awt.Image;
import java.awt.Button;
import java.awt.Frame;
import java.awt.FlowLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Canvas;
import java.awt.Scrollbar;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Component;
import java.awt.Font;

import java.awt.event.*;
import java.lang.*;

// Penalty Applet: This applet has all the components to show penalty kicks.
// Applet itself conatains simple images and a button for start-up.
// Penalty Applet pops up a new frame with necassary component and functionalities, which
// show main penalty kicks.
// 
public class Penalty  extends Applet { 
  private Button netButton;   // to pop up frame, press "Front Net" button.
  private Image kale,saha,top,kaleci,kaleciL,kaleciR; //pre load image names
  //please not that some variables are just added for future extentions, like
  // moving gool keeper.

  public void init() { 
    setLayout(new FlowLayout() );     // don't need complicated layout, 
                               //include one button and images
    netButton = new Button("Front Net");
    netButton.addActionListener(new ButtonHandler(this));  //to open netwindow
    add(netButton);
    saha=getImage(getDocumentBase(), "kaleBig.gif")	;
    kale=getImage(getDocumentBase(), "kale.gif")	;
    top=getImage(getDocumentBase(), "top.gif")	;
  }
  //just draw images to the applet
  public void paint (Graphics g)  { 
    g.drawImage(saha,1,1,this);
    g.drawImage(kale,1,1,this);
    g.drawImage(top,1,1,this);
  }
  
  public void test () { System.out.println("test");}

} ///Penalty

// to perform action when "Front Net" button pressed in Penalty applet
class ButtonHandler implements ActionListener 
{
  NetWindow net;
  Penalty of;

  public ButtonHandler(Penalty _of){ of=_of;  }
  public void actionPerformed(ActionEvent e)  { 
    net = new NetWindow("Penalty Shootings");  //open net window frame
    net.setParent(of);                        //send applet to the frame for image loading
    net.setSize(550,550);	
  }
}//ButtonHandler
//______________________________________________________________________

//show actual Net and penalty shootings

class NetWindow extends Frame implements ActionListener { //, ItemListener,AdjustmentListener{
  private Button quit,shoot;       // action buttons to exit and penalty shootings
  private Scrollbar Hscrollbar;   // to adjust target point of the penalty
  private Scrollbar Vscrollbar;
  private  DrawCanvas kale;      // include penalty images
  private Penalty applet;         // parent of the frame, for image loading purposes 

  // get parent applet and send it to the child components, 
  // for necessary methods of applet.
  public void setParent(Penalty a ) {
    applet =a;
    kale.setApplet(applet);
    kale.start();
    kale.setBallX(Hscrollbar.getValue() );
    kale.setBallY(Vscrollbar.getValue() );
  }
  // constructor
   NetWindow(String title) {
    super(title);
    GridBagLayout gbl = new GridBagLayout(); //use GridBagLayout
    setLayout(gbl);

    int min = 0;    // minimum value of scrollbar
    int max = 100;  // maximum value of scrollbar
    int pos = 50;   // initial position of scrollbox
    int size = 5;   // relative size of the scrollbox
    Color lightBlue = new Color( 0xB0, 0xE0, 0xE6 );
         
    int orientation = Scrollbar.HORIZONTAL;
    Hscrollbar = new Scrollbar( orientation, pos, size, min, max );
    Hscrollbar.setBlockIncrement(10);
    Hscrollbar.setBackground( lightBlue );
    Hscrollbar.addAdjustmentListener( new ScrollbarHandlerX() );
 
    max = 95;  // maximum value of scrollbar
    orientation = Scrollbar.VERTICAL;
    Vscrollbar = new Scrollbar( orientation, pos, size, min, max );
    Vscrollbar.setBlockIncrement(10);
    Vscrollbar.setBackground( lightBlue );
    Vscrollbar.addAdjustmentListener( new ScrollbarHandlerY() );

    //scrollbars
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.weightx = 100;
    gbc.weighty = 0;
    add(Hscrollbar, gbl, gbc, 0, 10, 10, 1);
   
    gbc.fill = GridBagConstraints.VERTICAL;
    gbc.weightx = 0;
    gbc.weighty = 100;
    add(Vscrollbar, gbl, gbc, 10, 0, 1, 9);

    //canvas
    kale=new DrawCanvas();
    kale.setBackground(new Color(0,128,0));
    gbc.fill = GridBagConstraints.BOTH;
    gbc.weightx = 100;
    gbc.weighty = 100;
    add(kale, gbl, gbc, 0, 0, 10, 10);


    //buttons
    quit=new Button("X");
    quit.addActionListener(this);
    quit.setBackground( Color.red );
    quit.setForeground( Color.white ); 
    quit.setFont(new Font("SansSerif", Font.BOLD,12));

    shoot=new Button("!");
    shoot.addActionListener(this);
    shoot.setBackground( Color.blue );
    shoot.setForeground( Color.white ); 
    shoot.setFont(new Font("SansSerif", Font.BOLD,12));

    gbc.fill = GridBagConstraints.NONE;
    gbc.weightx = 0;
    gbc.weighty = 0;
    add(quit,gbl, gbc,10,10,1,1);
    add(shoot,gbl, gbc,10,9,1,1);
   
    setSize(550,550); 
    setVisible(true);
  }
  // carry GridBagLayout parameters 
  private void add(Component c, GridBagLayout gbl, GridBagConstraints gbc, 
                   int x, int y, int w, int h) {
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = w;
    gbc.gridheight = h;
    gbl.setConstraints(c, gbc);
    add(c);
  }
  ///EVENTS
  ///EVENTS
  ///EVENTS
  public void actionPerformed( ActionEvent e) {
    if (e.getSource()==quit)
      dispose();
    if (e.getSource()==shoot) {
       kale.shoot();
       System.out.println("shooting");
       
    }
  }
  
  //horizontal scrollbar listener
  class ScrollbarHandlerX implements AdjustmentListener {
    public void adjustmentValueChanged( AdjustmentEvent event ) {
      int v = event.getValue();
      kale.setBallX(v);
    }
  }
  //vertical listener
  class ScrollbarHandlerY implements AdjustmentListener {
    public void adjustmentValueChanged( AdjustmentEvent event ) {
      int v = event.getValue();
      kale.setBallY(v);
    }
  }
} //NetWindow

// show the net, ball images, provide animations for penalty kicks
class DrawCanvas extends Canvas 
{

  Graphics g;
  boolean noball=false;  //to keep the position of ball
  Graphics bufferg; //,appletG;
  Penalty applet;  //to be used for image loading
  Ball ball;       // controls ball animation
  Image kale,top,kaleci,vuran; // images, some for future extention
  Image buffer;   // used in double buffering 
  int topx,topy,w,h; // the target point of ball kick
  double rx,ry;     

  //constructor
  public DrawCanvas() {
    setForeground(Color.red);
  }

  //set the x dimension of the target
  public void setBallX( int x) {      
    topx=(int)( x*rx)+25;
    repaint();
  }
  //set the y dimension of the target
  public void setBallY( int y) {
    topy=(int)(y*ry)+25;  repaint();
  }
  //to be used for image loading
  public void setApplet(Penalty a ) {      
    applet =a;
  }

  //prepare penalty kick; images, etc.
  public void start( ) {
    kale  = applet.getImage(applet.getDocumentBase(), "kaleBig.gif")	;
    w= getSize().width;
    h=getSize().height;
    rx=(double)(w-55)/95.0;
    ry=(double)(h-75)/90.0;
    buffer=createImage(getSize().width,getSize().height);
    bufferg=buffer.getGraphics();
    bufferg.drawImage(kale,0,0, applet);
    ball =new Ball(this, w/2 -50/2, h*10/12);
  }
  public void ballgone( ) {
    noball=true;
  }

  //perform penalty shoot
  public void shoot( ) {
    if (noball) {
      noball=false;
      ball =new Ball(this, w/2 -50/2, h*10/12);
      repaint();
      return;
    }
    ball.setTarget(topx,topy);
    ball.start();
  }
  public void paint(Graphics g) {
	  
    //super.paint(g);
    g.drawImage(buffer, 0, 0, applet);
    g.fillOval(topx, topy, 11,11);
    ball.draw(g);
  }
} //draw canvas class ends 


// keep track ball animation 
class Ball implements Runnable  {
  private Thread thread;        // a thread
  DrawCanvas  parent;
  Image top;
  int tx,ty;
  double size;
  double x,y,dx=5;
  double  dv,ds,dy=5;
  double v=10;

  // constructor
  public Ball(DrawCanvas p,int _x, int _y) {
    parent=p;
    x=_x; y=_y;
    top  = parent.applet.getImage(parent.applet.getDocumentBase(), "top.gif")	;
    size=top.getWidth(parent.applet);
    v=10;
  }

  //draw ball on the parent canvas class
  public void draw(Graphics g) {
    g.drawImage(top,(int)x,(int)y,(int)size,(int)size , parent.applet);
  }
  //
  public void init () 
  {}
  // set the penalty target point of the ball
   public void setTarget(int _x, int _y) {
    tx=_x;
    ty=_y;
    dx=(double)(tx-x)/60.0;
    dy= (double)(y-ty)/60.0;
    ds=size/95.0;
    dv=15.0/100.0;
  }
  // move ball in a delta distance towards target point for animation 
  public void move() {
    x+=dx; y-=dy;
    size-=ds;
    v+=dv;
    parent.repaint();
    //if (y <ty  (x <tx+10 || x> tx-10)) thread.stop(); 
    if (y <ty  ){  parent.ballgone();       thread.stop(); }
  }
  //start thread ; penalty shoot        
  public void start() 
  {
    if ( thread == null ) 
    { thread = new Thread( this );
      thread.start();
    }
  }  
  // Override java.applet.Applet.stop:
  // stop thread; ball reached to the target
  public void stop() 
  {
    if ( thread != null ) 
    { thread.stop();
      thread = null;
    }
  }
   
  // Implement java.lang.Runnable.run:
  // make moving ball animation
  public void run() 
  {
    while ( thread != null ) {
      move();
      try {
	Thread.sleep((int)v);
      } catch ( InterruptedException e ) {   };    // Do nothing  
    }
  }
} //ball class end 









