/*
	A basic extension of the java.applet.Applet class
 */
import java.io.Serializable;
import java.net.URL;
import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.lang.Math ;
import java.awt.*;
import java.applet.*;
import java.awt.event.*;
 
class Muhabere implements MuhabereInterface,	Serializable  {
    MuhabereInterface myp=null;
    GameServerInterface server;
    GameBase base;
    int port=2002;
    
    Muhabere(GameBase _base)
    {
	base=_base;
    }
    public void print (String message)  throws RemoteException
    {
	System.out.println(message);
    }
    public void displayMessage(String message)  throws RemoteException
    {
	base.networkMessage(message);
    }

    public boolean updatePlayerList(Hashtable pl) throws RemoteException
    {
	base.refreshPlayers(pl);
	return true;
    }

    public boolean askPartnership(String candidate,String old)
    {
	try 
	    {  System.out.println("askPartnership(String candidate,String old)");
		myp=server.askPartnership(base.mystate.name,candidate,old); 
		 System.out.println("\t\t"+myp);
	       if (myp!=null) return true; 
	    }
	catch (Exception e)    
	    {  System.out.println("Client askPartnership ");   e.printStackTrace();
	    }
	return false; 
    }
    public void movePartner(String obj,int x,int y,int z)
    {
      //System.out.println("sending  to"+base.mystate.partner);
	try 
	    { if (myp != null) myp.adaptPartner(obj,x,y,z) ; 
	    }
	catch (Exception e)    
	    { System.out.println("Client error: Muharebe.movePartner()");   e.printStackTrace();
	      myp= null;
	      base.lostPartner();
	    }
    }

    public void adaptPartner(String obj,int x,int y,int z)
    {
      //System.out.println("receiving from partner"+obj);
	try 
	    { base.moveTo(obj,x,y,z);
	    }
	catch (Exception e)    
	    { System.out.println("Client error: Muharebe.receive()");   e.printStackTrace();
	    }
    }

    public boolean available(String requester,MuhabereInterface r) 
    {
	System.out.println("available(String requester,MuhabereInterface r) ");
	
	if (base.setPartner(requester)) 
	    {
		myp=r;
		System.out.println("available");
		return true;
	    }
	return false;
    }

    public void deselect(String requester) 
    {
	myp=null;
	base.deselectPartner(requester);
    }
    public void update(playerstate pl)
    {
	System.out.println("update(playerstate pl)");
	pl.print("updating mystate :");
	try     
	    { server.update(pl.name,(Object)pl); }
	catch (Exception e)        
	    { System.out.println("Client error: Muharebe.update()");   e.printStackTrace();
	    }
    }

    public void login(playerstate pl){ 
	try     
	    { server.login(this,(Object)pl,pl.name); }
	catch (Exception e)    
	    { System.out.println("Client error: Muharebe.login()"); e.printStackTrace();
	    }
    }

    public void logout(playerstate pl)
    { 
	try     
	    { server.logout(pl.name); }
	catch (Exception e)    
	    { System.out.println("Client error: Muharebe.logout()"); e.printStackTrace();
	    }
    }

    public void register() 
    {
	boolean registered=false;
        int tries=0;
	while(!registered && tries <10) 
	    try
	    {
		System.out.println("Registering to server");
		server.register(this);  
		registered=true;
		System.out.println("done");
	    }
	catch (Exception e)
	    {
		tries++;
		connect();		//e.printStackTrace();
		return;
	    }
    }
    
    public void connect()
    {   
	try
	    { UnicastRemoteObject.exportObject(this);
	    }
	catch (Exception e)
	    { System.out.println("Error exporting ");  e.printStackTrace();
	    }
	try
	    { server = (GameServerInterface) Naming.lookup("//carver.npac.syr.edu:2003/GameServer");
	    }
	catch (Exception e)
	    {
		System.out.println("Error while lookup : server may be down"); e.printStackTrace();
		startServer();
	    }
	 
    }

    public void   startServer()
    {
	//         String command = "/usr/npac/java/bin/java .../GameServer &";

	//         try{
	//           BufferedReader HTML = null;
	//           URL url = new URL("http",host,URLPort,command);
	//           url.openConnection().setUseCaches(false);
	//           HTML=new BufferedReader(new InputStreamReader(url.openStream()));
	//          }catch (MalformedURLException ev){
	//            System.out.println("URL error in (run) " + ev);
	//          }
	//          catch (IOException ev){
	//            System.out.println("IOException in (run)"+ev+" host "+host+" URLPort "+URLPort+" command "+command);
	//          }
	//          boolean flag=false;
    }
} //Muhabere

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
class  playerstate implements     Serializable
{
    public String  name;
    public String  partner=null;
    public boolean goalie;
    public boolean active=false;
    public boolean catching=false;
    public boolean shooting=false;
  
    playerstate (String _name,boolean g)
    {
	name=_name;
	goalie=g;
    }
    public void  print (String m){
	System.out.println(m+name+"partner "+partner+goalie+active+catching+shooting);
    }
}

public class GameBase extends Applet implements     Serializable
{

    //CONTROLS
    Panel networkPanel = new Panel();
    List gList = new List(30);
    List pList = new List(30);
    Checkbox pRB = new Checkbox();
    CheckboxGroup Group1 = new CheckboxGroup();
    Label nameLabel = new Label();
    TextField loginTxtField = new TextField();
    Button loginButton = new Button();
    Button logoutButton = new Button();
    Checkbox gRB = new Checkbox();
    Label statusLabel = new Label();
    Button startButton = new Button();
     //
    Muhabere network=new Muhabere(this);
    playerstate mystate;    
    String login="";

    public void init()
    {
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(Color.pink);
		setSize(450,300);
		networkPanel.setLayout(null);
		add(networkPanel);
		networkPanel.setBackground(new Color(128,255,128));
		networkPanel.setBounds(200,0,250,270);
		gList.addItem("login first");
		gList.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		gList.setBackground(Color.black);
		gList.setForeground(Color.lightGray);
		gList.setFont(new Font("Dialog", Font.BOLD, 12));
		networkPanel.add(gList);
		gList.setBounds(5,75,120,190);
		pList.addItem("login first");
		pList.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		pList.setBackground(new Color(0,128,0));
		pList.setForeground(Color.yellow);
		pList.setFont(new Font("Dialog", Font.BOLD, 12));
		networkPanel.add(pList);
		pList.setBounds(125,75,120,190);
		pRB.setCheckboxGroup(Group1);
		pRB.setLabel("Player");
		pRB.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		networkPanel.add(pRB);
		pRB.setBackground(Color.yellow);
		pRB.setForeground(new Color(0,128,0));
		pRB.setFont(new Font("Dialog", Font.BOLD, 12));
		pRB.setBounds(125,55,120,20);
		nameLabel.setText(" Player Name");
		nameLabel.setAlignment(Label.CENTER);
		nameLabel.setCursor(Cursor.getPredefinedCursor(Cursor.E_RESIZE_CURSOR));
		networkPanel.add(nameLabel);
		nameLabel.setBackground(new Color(0,128,128));
		nameLabel.setForeground(Color.yellow);
		nameLabel.setFont(new Font("Dialog", Font.BOLD, 12));
		nameLabel.setBounds(5,5,120,30);
		loginTxtField.setText("none");
		networkPanel.add(loginTxtField);
		loginTxtField.setBackground(new Color(196,227,224));
		loginTxtField.setBounds(125,5,120,30);
		loginButton.setLabel("Login");
		loginButton.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		networkPanel.add(loginButton);
		loginButton.setBackground(new Color(0,64,128));
		loginButton.setForeground(Color.yellow);
		loginButton.setFont(new Font("Dialog", Font.BOLD, 14));
		loginButton.setBounds(5,35,120,20);
		logoutButton.setLabel("Logout");
		logoutButton.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		networkPanel.add(logoutButton);
		logoutButton.setBackground(Color.red);
		logoutButton.setForeground(Color.yellow);
		logoutButton.setFont(new Font("Dialog", Font.BOLD, 12));
		logoutButton.setBounds(125,35,120,20);
		gRB.setCheckboxGroup(Group1);
		gRB.setState(true);
		gRB.setLabel("Goalie");
		gRB.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		networkPanel.add(gRB);
		gRB.setBackground(Color.lightGray);
		gRB.setForeground(Color.black);
		gRB.setFont(new Font("Dialog", Font.BOLD, 12));
		gRB.setBounds(5,55,120,20);
		
		statusLabel.setText("Please login first");
		statusLabel.setAlignment(Label.CENTER);
		add(statusLabel);
		statusLabel.setBackground(Color.orange);
		statusLabel.setBounds(0,270,449,30);
		startButton.setLabel("start game");
		add(startButton);
		startButton.setBackground(Color.red);
		startButton.setForeground(Color.white);
		startButton.setFont(new Font("Dialog", Font.BOLD, 16));
		startButton.setBounds(5,5,190,30);
		//}}

		//{{REGISTER_LISTENERS
		SymItem lSymItem = new SymItem();
		gRB.addItemListener(lSymItem);
		pRB.addItemListener(lSymItem);
		pList.addItemListener(lSymItem);
		SymAction lSymAction = new SymAction();
		gList.addActionListener(lSymAction);
		gList.addItemListener(lSymItem);
		loginButton.addActionListener(lSymAction);
		SymText lSymText = new SymText();
		loginTxtField.addTextListener(lSymText);
		startButton.addActionListener(lSymAction);
		logoutButton.addActionListener(lSymAction);
		//}}
		
		
    saha=getImage(getDocumentBase(), "kaleBig.gif")	;
    kale=getImage(getDocumentBase(), "kale.gif")	;
    top=getImage(getDocumentBase(), "top.gif")	;
    kaleci=getImage(getDocumentBase(), "kaleci.gif")	;
    kaleciL=getImage(getDocumentBase(), "yakaliyorL.gif")	;
    kaleciR=getImage(getDocumentBase(), "yakaliyorR.gif")	;
    yakaladi=getImage(getDocumentBase(), "yakaladi.gif")	;
    
    mystate= new playerstate(loginTxtField.getText() ,gRB.getState());
    System.out.println("Looking network connections.");
    network.register();
    }

    private Image kale,saha,top,kaleci,kaleciL,kaleciR,yakaladi; //pre load image names
    public void paint (Graphics g)  
    { 
	g.drawImage(kaleci,350,0,this);
	g.drawImage(kaleciL,350,0,this);
	g.drawImage(kaleciR,350,0,this);
	g.drawImage(yakaladi,350,0,this);
	g.drawImage(saha,250,0,this);
	g.drawImage(kale,-70,50,this);
	g.drawImage(top,75,100,this);
    }

    public void destroy()
    {
	  network.logout(mystate);
    }
    public void deactivate()
    {
	mystate.active=false;
	network.update(mystate);
    }
    
    public void lostPartner()
    {
	      mystate.partner=null;
	      network.update(mystate);
    }
   
    public void networkMessage(String m) 
    {
	
	if (m.indexOf("leave")>0 ||m.indexOf("join")>0) {
	     Toolkit.getDefaultToolkit().beep();
	     if (m.indexOf(mystate.partner+" leave")==0)
		 { mystate.partner=null; network.update(mystate);}
		  
	}
	statusLabel.setText(m);
    }

    public void inAction() 
    {
	mystate.catching=true;
	mystate.shooting=true;
	network.update(mystate);
	statusLabel.setText("P E N A L T Y");
    }
    public void actionEnd() 
    {
	mystate.catching=false;
	mystate.shooting=false;
	network.update(mystate);
	statusLabel.setText("....");
    }

		  

    public void refreshPlayers(Hashtable pl) {
	
	//System.out.println("refreshing");
	try 
	    {
		
		pList.removeAll();
		gList.removeAll();
		playerstate p;
		String u;
		int gI=0,pI=0;
		Enumeration e = pl.elements();
		while (e.hasMoreElements())
		    {
			p  = (playerstate) e.nextElement();
			u=p.name;
			if (p.partner!=null) 
			    u="~"+u;
			if (p.goalie) {
			    if (p.active) {
				if (p.catching) 
				    u+= " @";
				else u+= " !";
			    }
			    gList.add(u);
			    if (mystate.partner!=null&&mystate.partner.equals(p.name)) 
				{gList.select(gI);}
			    gI++;
			} else {
			    if (p.active) {
				if (p.shooting)
				    u+= " *";
				else u+= " !";
			    }
			    pList.add(u);
			    if (mystate.partner!=null&&mystate.partner.equals(p.name)) 
				{pList.select(pI);}
			    pI++;
			}
		    }
	    }   
	catch (Exception e)
	    { System.out.println("Error while refreshing.");  e.printStackTrace();
	    }
    }

    public boolean setPartner(String p)
    {
	System.out.println("setPartner(String p)"+p);
	if (mystate.partner==null ) {
	    mystate.partner=p;
//  	    List l;
//  	    if (mystate.goalie) 
//  		l=pList;
//  	    else l=gList;
//  	    for (int i=0; i<l.getItemCount() ;i++) 
//  		if (p.equals(l.getItem(i)))
//  		    l.select(i);
	    statusLabel.setText(p+ " invites you to play");
	    network.update(mystate);
	    return true;
	}
	else if (mystate.partner.equals(p) ) return true;
	else return false;
    }

    public void  deselectPartner(String p)
    {
	if (mystate.partner.equals(p)) {
	    mystate.partner=null;
	    List l;
	    if (mystate.goalie) 
		l=pList;
	    else l=gList;
	    l.deselect(l.getSelectedIndex());
	    statusLabel.setText ( p + " says bye bye to you.");
	    network.update(mystate);
	}
    }

    public void  moveTo(String otype,int x,int y,int z)
    {
	if (net !=null)
	      net.kale.moveTo(otype,x,y,z);
    }

    // actions
	class SymItem implements ItemListener
	{
		public void itemStateChanged(ItemEvent event)
		{
			Object object = event.getSource();
			if (object == gRB)
				gRB_ItemStateChanged(event);
			else if (object == pRB)
				pRB_ItemStateChanged(event);
			else if (object == pList)
				pList_ItemStateChanged(event);
			else if (object == gList)
				gList_ItemStateChanged(event);
		}
	}

	void gRB_ItemStateChanged(ItemEvent event)
	{
		// to do: code goes here.
			 
		gRB_ItemStateChanged_Interaction1(event);
			 
		gRB_ItemStateChanged_Interaction2(event);
	}

	void pRB_ItemStateChanged(ItemEvent event)
	{
		// to do: code goes here.
			 
		pRB_ItemStateChanged_Interaction1(event);
			 
		pRB_ItemStateChanged_Interaction2(event);
	}

	void pList_ItemStateChanged(ItemEvent event)
	{
	  list_ItemStateChanged(pList,pRB);
	  // to do: code goes here.
		
	  //		pList_ItemStateChanged_Interaction1(event);
	}

	void pList_ItemStateChanged_Interaction1(ItemEvent event)
	{
		try {
			statusLabel.setText(pList.getSelectedItem());
		} catch (Exception e) {
		}
	}

	class SymAction implements ActionListener
	{
		public void actionPerformed(ActionEvent event)
		{
			Object object = event.getSource();
			if (object == gList)
				gList_ActionPerformed(event);
			else if (object == loginButton)
				loginButton_ActionPerformed(event);
			else if (object == startButton)
				startButton_ActionPerformed(event);
			else if (object == logoutButton)
				logoutButton_ActionPerformed(event);
		}
	}

	void gList_ActionPerformed(ActionEvent event)
	{
		// to do: code goes here.
	}

	void gList_ItemStateChanged(ItemEvent event)
	{
	  list_ItemStateChanged(gList,gRB);
	}
  void list_ItemStateChanged(List lst,Checkbox rb) {

		// to do: code goes here.
	  String si=lst.getSelectedItem();
	  int  i=lst.getSelectedIndex();
	 
	  si=si.replace('~',' ').replace('@',' ').replace('*',' ').replace('!',' ').trim();
	  //System.out.println(si);
	  //for (int in=0;in <255;in++)  System.out.print((char)in+in);
	  if (mystate==null) {
	    statusLabel.setText("Login first");
	    lst.deselect(i); 
	  }
	  else if (  rb.getState()  || mystate.name.equals(si) ) {
	     lst.deselect(i); 
	     statusLabel.setText("Illegal selection");
	     return;
	  }  
	  else if (network.askPartnership(si, mystate.partner)) {
	    mystate.partner=si;
	    System.out.println("Play with-"+si+"+");
	    statusLabel.setText("Play with "+si);
	    network.update(mystate);
	    mystate.print("UPDATE");    
	  } else { 
	      System.out.println(si+" is not accepted");
	    lst.deselect(i);   
	    statusLabel.setText("Leave partner");
	    mystate.partner=null;
	    network.update(mystate);
	  }
	  //  gList_ItemStateChanged_Interaction1(event);
	}

	void gList_ItemStateChanged_Interaction1(ItemEvent event)
	{
		try {
			statusLabel.setText("Play with "+gList.getSelectedItem());
		} catch (Exception e) {
		}
	}

	void gRB_ItemStateChanged_Interaction1(ItemEvent event)
	{
		try {
			pRB.setState(false);
		} catch (Exception e) {
		}
	}

	void pRB_ItemStateChanged_Interaction1(ItemEvent event)
	{
		try {
			gRB.setState(false);
		} catch (Exception e) {
		}
	}

	void gRB_ItemStateChanged_Interaction2(ItemEvent event)
	{
		try {
			statusLabel.setText("You are goalie now");
		} catch (Exception e) {
		}
	}

	void pRB_ItemStateChanged_Interaction2(ItemEvent event)
	{
		try {
			statusLabel.setText("You are player now");
		} catch (Exception e) {
		}
	}

	void loginButton_ActionPerformed(ActionEvent event)
	{
	  network.logout(mystate);
	  mystate= new playerstate(loginTxtField.getText() ,gRB.getState());
	  network.login(mystate);
	  loginButton_ActionPerformed_Interaction1(event);
	}

	void loginButton_ActionPerformed_Interaction1(ActionEvent event)
	{
		try {
			statusLabel.setText("Login to the server");
		} catch (Exception e) {
		}
	}

	class SymText implements TextListener
	{
		public void textValueChanged(TextEvent event)
		{
			Object object = event.getSource();
			if (object == loginTxtField)
				loginTxtField_TextValueChanged(event);
		}
	}

	void loginTxtField_TextValueChanged(TextEvent event)
	{
		// to do: code goes here.
	  //mystate.name=loginTxtField.getText();
	  loginTxtField_TextValueChanged_Interaction1(event);
	}

	void loginTxtField_TextValueChanged_Interaction1(TextEvent event)
	{
		try {
			statusLabel.setText(loginTxtField.getText());
		} catch (Exception e) {
		}
	}

	  NetWindow net;
    void startButton_ActionPerformed(ActionEvent event)
    {
		// to do: code goes here.
			 
	startButton_ActionPerformed_Interaction1(event);
	if (mystate.goalie)
	    {
		net = new NetWindow("Penalty Shootings",false);  //open net window frame
		net.setSize(550,550);	
		net.setParent(this);                        //send applet to the frame for image loading
		mystate.active=true;
		network.update(mystate);
	    } 
	else 
	    {
		net = new NetWindow("Penalty Shootings",true);  //open net window frame
		net.setParent(this);                        //send applet to the frame for image loading
		net.setSize(550,550);	
		mystate.active=true;
		network.update(mystate);
	    }
	
    }

	void startButton_ActionPerformed_Interaction1(ActionEvent event)
	{
		try {
			statusLabel.setText("Starting the game");
		} catch (Exception e) {
		}
	}

	void logoutButton_ActionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			  network.logout(mystate); 
			  mystate=null;
		logoutButton_ActionPerformed_Interaction1(event);
	}

	void logoutButton_ActionPerformed_Interaction1(ActionEvent event)
	{
		try {
			statusLabel.setText("Leaving active play");
		} catch (Exception e) {
		}
	}

	void receiveB_ActionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		receiveB_ActionPerformed_Interaction1(event);
			 
		receiveB_ActionPerformed_Interaction2(event);
	}

	void receiveB_ActionPerformed_Interaction1(ActionEvent event)
	{
		try {
			gList.addItem("gelen");
			//Muhabere m=(Muhabere)
			//    network.es(mystate.partner);
			//network.print(" test test test test test test test");
		} catch (Exception e) {
		    e.printStackTrace();
		}
	}

	void receiveB_ActionPerformed_Interaction2(ActionEvent event)
	{
		try {
			gList.remove("leaving");
		} catch (Exception e) {
		}
	}
}
//______________________________________________________________________
//______________________________________________________________________
//______________________________________________________________________
//______________________________________________________________________
//______________________________________________________________________

//show actual Net and penalty shootings

class NetWindow extends Frame implements ActionListener,     Serializable  { //, ItemListener,AdjustmentListener{
  private Button quit,shoot;       // action buttons to exit and penalty shootings
  private Scrollbar Hscrollbar;   // to adjust target point of the penalty
  private Scrollbar Vscrollbar;
  public  DrawCanvas kale;      // include penalty images
  private GameBase applet;         // parent of the frame, for image loading purposes 

  // get parent applet and send it to the child components, 
  // for necessary methods of applet.
  public void setParent(GameBase a ) {
    applet =a;
    kale.setApplet(applet);
    kale.start();
    if  (!applet.mystate.goalie) {
	kale.setBallX(Hscrollbar.getValue() );
	kale.setBallY(Vscrollbar.getValue() );
    }
    
    //    applet.network.register(kale);
  }
  // constructor
   NetWindow(String title,boolean player) {
    super(title);
    GridBagLayout gbl = new GridBagLayout(); //use GridBagLayout
    setLayout(gbl);

    int min = 0;    // minimum value of scrollbar
    int max = 100;  // maximum value of scrollbar
    int pos = 50;   // initial position of scrollbox
    int size = 5;   // relative size of the scrollbox
    Color lightBlue = new Color( 0xB0, 0xE0, 0xE6 );
    GridBagConstraints gbc = new GridBagConstraints();
   
    if (player) {
    int orientation = Scrollbar.HORIZONTAL;
    Hscrollbar = new Scrollbar( orientation, pos, size, min, max );
    Hscrollbar.setBlockIncrement(10);
    Hscrollbar.setBackground( lightBlue );
    Hscrollbar.addAdjustmentListener( new ScrollbarHandlerX() );
 
    max = 95;  // maximum value of scrollbar
    orientation = Scrollbar.VERTICAL;
    Vscrollbar = new Scrollbar( orientation, pos, size, min, max );
    Vscrollbar.setBlockIncrement(10);
    Vscrollbar.setBackground( lightBlue );
    Vscrollbar.addAdjustmentListener( new ScrollbarHandlerY() );

    //scrollbars
    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.weightx = 100;
    gbc.weighty = 0;
    add(Hscrollbar, gbl, gbc, 0, 10, 10, 1);
   
    gbc.fill = GridBagConstraints.VERTICAL;
    gbc.weightx = 0;
    gbc.weighty = 100;
    add(Vscrollbar, gbl, gbc, 10, 0, 1, 9);

    } else {
	Button h=new Button();
	h.setBackground(Color.yellow);	
    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.weightx = 100;
    gbc.weighty = 0;
    add(h, gbl, gbc, 0, 10, 10, 1);
    Button v=new Button(".");
    v.setBackground(Color.white);	
    gbc.fill = GridBagConstraints.VERTICAL;
    gbc.weightx = 0;
    gbc.weighty = 100;
    add(v, gbl, gbc, 10, 0, 1, 10);

    }

    //canvas
    kale=new DrawCanvas();
    kale.setBackground(new Color(0,128,0));
    gbc.fill = GridBagConstraints.BOTH;
    gbc.weightx = 100;
    gbc.weighty = 100;
    add(kale, gbl, gbc, 0, 0, 10, 10);

    //buttons
    gbc.fill = GridBagConstraints.NONE;
    gbc.weightx = 0;
    gbc.weighty = 0;

    quit=new Button("X");
    quit.addActionListener(this);
    quit.setBackground( Color.red );
    quit.setForeground( Color.white ); 
    quit.setFont(new Font("SansSerif", Font.BOLD,12));
    add(quit,gbl, gbc,10,10,1,1);

    if (player) {
    
    shoot=new Button("!");
    shoot.addActionListener(this);
    shoot.setBackground( Color.blue );
    shoot.setForeground( Color.white ); 
    shoot.setFont(new Font("SansSerif", Font.BOLD,12));
    add(shoot,gbl, gbc,10,9,1,1);
    }
    setSize(550,550); 
    setVisible(true);
  }
  // carry GridBagLayout parameters 
  private void add(Component c, GridBagLayout gbl, GridBagConstraints gbc, 
                   int x, int y, int w, int h) {
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = w;
    gbc.gridheight = h;
    gbl.setConstraints(c, gbc);
    add(c);
  }
  ///EVENTS
  ///EVENTS
  ///EVENTS
  public void actionPerformed( ActionEvent e) {
      if (e.getSource()==quit) {
	  applet.deactivate();
	  dispose();
      }
    if (e.getSource()==shoot) {
      if (!applet.mystate.goalie)
	kale.shoot();
	 System.out.println("shooting");
    }
  }
  
  //horizontal scrollbar listener
  class ScrollbarHandlerX implements AdjustmentListener {
    public void adjustmentValueChanged( AdjustmentEvent event ) {
      int v = event.getValue();
      kale.setBallX(v);
    }
  }
  //vertical listener
  class ScrollbarHandlerY implements AdjustmentListener {
    public void adjustmentValueChanged( AdjustmentEvent event ) {
      int v = event.getValue();
      kale.setBallY(v);
    }
  }

} //NetWindow

// show the net, ball images, provide animations for penalty kicks
class DrawCanvas extends Canvas // implements Serializable
{
    Graphics g;
    boolean noball=false;  //to keep the position of ball
    Graphics bufferg; //,appletG;
    GameBase applet;  //to be used for image loading
    Ball ball;       // controls ball animation
    Goalie goalie;       // controls ball animation
    Image kale;  // images, some for future extention
    Image buffer;   // used in double buffering 
   
    int topx,topy,w,h; // the target point of ball kick
    double rx,ry;     

    public DrawCanvas() 
    {
	setForeground(Color.red);
	addMouseListener(mouse);
    }

    MouseListener mouse = new MouseAdapter() {
	public void mousePressed(MouseEvent e) {
	    if (applet.mystate.goalie && goalie!=null)
	    goalie.setTarget(e.getX(),e.getY());
	}
    }  ;            


    //to be used for image loading
    public void setApplet(GameBase a ) 
    {      
	applet =a;
    }
    //set the x dimension of the target
    public void setBallX( int x) 
    {      
	topx=(int)( x*rx)+25;
	repaint();
    }
    //set the y dimension of the target
    public void setBallY( int y) 
    {
	topy=(int)(y*ry)+25;  repaint();
    }
    public void ballgone( ) 
    {
	noball=true;
	applet.actionEnd();
	ball.stop();
    }
    //prepare penalty kick; images, etc.
    public void start( ) 
    {
	kale  = applet.getImage(applet.getDocumentBase(), "kaleBig.gif")	;
	w= getSize().width;
	h=getSize().height;
	rx=(double)(w-55)/95.0;
	ry=(double)(h-75)/90.0;
	buffer=createImage(getSize().width,getSize().height);
	bufferg=buffer.getGraphics();
	bufferg.drawImage(kale,0,0, applet);
	ball =new Ball(this, w/2 -50/2, h*10/12,100);
	goalie =new Goalie(this, w/2 -50/2, 250,0);
    }
    public void shoot( ) 
    {
	if (noball) {

	    noball=false;
	    ball =new Ball(this, w/2 -50/2, h*10/12,100);
	    goalie =new Goalie(this, w/2 -50/2, 250,0);
	    //applet.network.movePartner("Ball",w/2 -50/2, h*10/12,100);
	    applet.network.movePartner("NewBall",w/2 -50/2, h*10/12,100);
	    repaint();
	    System.out.println("ew Ball(this, w/2 -50/2, h*10/12,100);");
	    return;
	}
	applet.inAction();
	ball.setTarget(topx,topy);
	ball.start();
    }
    public void  moveTo(String o,int x,int y, int z)
    {
	//System.out.println("kale movinTo "+o+" "+x+y+z);
	if (o.equals("Ball")) { 
	  ball.moveTo(x,y,z);
	  if (z <20 && goalie.tryToCatch(x,y,z)) {
	    ballgone();  
	  }
	}
	else if (o.equals("Together")) { 
	    ballgone();   
	    goalie.together();
	}
	else if (o.equals("NewBall")) { 
	    noball=false;
	    ball.moveTo(w/2 -50/2, h*10/12,100);
	    goalie.waiting();
	}
	else goalie.moveTo(x,y,z);
       
    }
    //perform penalty shoot
    public void update(Graphics g) 
    {
	paint(g);
    }
    public void paint(Graphics g) 
    {
	g.drawImage(buffer, 0, 0, applet);
	g.fillOval(topx, topy, 11,11);
// 	for (int i=0;i<500;i+=50)
// 	  g.fillOval(i, i, 11,11);
// 	for (int i=0;i<500;i+=10)
// 	  g.fillRect(i, i, 5,5);
	if (ball!=null &&!noball)
	  ball.draw(g);
	goalie.draw(g);
    }

} //draw canvas class ends 


// keep track ball animation 
class MyObject implements Runnable {
  Thread thread;        // a thread
  DrawCanvas  parent;
  Image pic;
  int tx,ty,tz;
  double size,s;
  double x,y,z=5;
  double  dv,ds,dx,dy,dz=5;
  double v=10;
  boolean started=false;
  int ground=250;
  public MyObject(DrawCanvas p,int _x, int _y,int _z,String id, String picture) 
  { 
    parent=p;
    x=_x; y=_y; z=_z;
    pic  = parent.applet.getImage(parent.applet.getDocumentBase(), picture)	;
    size=pic.getWidth(parent.applet);
     s=size;
    v=10;
    parent.applet.network.movePartner(id,(int)x,(int)y,(int) z);
  }
  public void  moveTo(int _x,int _y, int _z)
  {
    x=_x;
    y=_y;
    z=_z;
    size=s*(1-(100-z)/150);
    //System.out.println(size);
    parent.repaint();
    
  }

  //start thread ; penalty shoot        
  public void start() 
  {
    if ( thread == null ) 
      { 
	thread = new Thread( this );
	thread.start();
      }
  }  
  // Override java.applet.Applet.stop:
  // stop thread; ball reached to the target
  public void stop() 
  {
    if ( thread != null ) 
      { 
	thread.stop();
	thread = null;
      }
  }
  public void  move(){}
  // Implement java.lang.Runnable.run:
  // make moving ball animation
  public void run() 
  {
    while ( thread != null ) 
      {
	move();
	try 
	  { Thread.sleep((int)v);
	  } 
	catch ( InterruptedException e ) 
	  {   
	  };    // Do nothing  
      }
  }
} //ball class end 




// keep track ball animation 
class Ball extends MyObject  {
  public Ball(DrawCanvas p,int _x, int _y,int _z) 
  { 
    super(p,_x,_y,_z,"Ball","top.gif");
  }
  // move ball in a delta distance towards target point for animation 
  public void move() {
    size=s*(1-(100-z)/150);
    x+=dx; y+=dy; z+=dz;
    //    size-=ds;
    v+=dv;
    //System.out.println("move(x,y);"+x+y);
    parent.applet.network.movePartner("Ball",(int)x,(int)y,(int) z);
    parent.repaint();
    if (z <tz  ){ 
	y=ground;
	parent.applet.network.movePartner("Ball",(int)x,(int)y,(int) z);
	parent.repaint();
	parent.ballgone();    
    }
  }
  public void draw(Graphics g)   //draw ball on the parent canvas class
  {
    g.drawImage(pic,(int)x,(int)y,(int)size,(int)size , parent.applet);
  }
  public void setTarget(int _x, int _y) 
  {
    tx=_x;
    ty=_y;
    tz=0;
    dx=(double)(tx-x)/60.0;
    dy= (double)(ty-y)/60.0;
    dz= (double)(tz-z)/60.0;
    //ds=size/95.0;
    //ds=(double)(size-50.0)/100.0;
    dv=15.0/100.0;
  }

} //ball class end 



// keep track ball animation 
class Goalie extends MyObject  {  
  int jump=200;
  int knee=300;
  int mid=250;
  int dir;
  int aroundR,aroundL;
  boolean landed=true;
    boolean yakalandi=false;
  double V,t;
    public Goalie(DrawCanvas p,int _x, int _y,int _z) 
    { 
     
	super(p,_x,_y,_z,"Goalie","kaleci.gif");
    }

  public boolean  tryToCatch(int bx,int by,int bz) {
      if (yakalandi) return true;
    int cx=(int)x-bx;
    int cy=(int)y-by;
    if (cx<0)cx*=-1;
    if (cy<0)cy*=-1;

    if (bz<=0) parent.ballgone();
    if (cx<40&&cy<80) {
      	pic  = parent.applet.getImage(parent.applet.getDocumentBase(), "yakaladi.gif")	;
	//System.out.print("YAKALADIM");
	//y=ground-30;
	yakalandi=true;
	parent.ballgone();
	//parent.applet.network.movePartner("Goalie",(int)x,(int)y,(int) z);
	parent.applet.network.movePartner("Together",(int)x,(int)y,(int) z);
	parent.repaint();
	
	return true;
    }
    
    return false;
  }

  public void together() {
    //System.out.print("YAKALAMIS");
       yakalandi=true;
    pic  = parent.applet.getImage(parent.applet.getDocumentBase(), "yakaladi.gif")	;
    parent.repaint();
  
}
  public void waiting()   //draw ball on the parent canvas class
  {
       yakalandi=false;
    pic  = parent.applet.getImage(parent.applet.getDocumentBase(), "kaleci.gif")	;
  }

  public void draw(Graphics g)   //draw ball on the parent canvas class
  {
    g.drawImage(pic,(int)x,(int)y, parent.applet);
  }


    public void move() {
      t++;
      x+=dx; 
      y+=(dy+.09*t)*t;
      //v+=dv; 
      // System.out.print("t="+t+" y="+y+" dx="+dx+" dy="+dy);
    
      if (y>ground+5) {y=ground; dy=0; landed=true;       parent.applet.actionEnd();}
      parent.applet.network.movePartner("Goalie",(int)x,(int)y,(int) z);
      parent.repaint();
      if (landed) {
	  if (!yakalandi)
	      pic  = parent.applet.getImage(parent.applet.getDocumentBase(), "kaleci.gif")	;
	y=ground;
	thread.suspend();
      }
  }
    public void setTarget(int _x, int _y) 
    {
      if (!landed || yakalandi) return;
      parent.applet.inAction();

      v=10;
      landed=false;
      t=0;
      ty=_y;
      //dir=60;
	tx=_x;
	tz=0;
      aroundR=tx+10;
      aroundL=tx-10;
      V=3.0;
      double disx=(double)(tx-x);
      double disy=(double)(ty-y);
      double dist=Math.sqrt(disy*disy+disx*disx);
      if (dist<100)
	  V=3.0;
      else if (dist<150)
	  V=4.0;
      else if (dist<200)
	  V=5.0;
      else V=6.0;
      
      dx=(double)(disx*V)/dist;
      dy=(double)(disy*V)/dist;

      if (dx>0)
		pic  = parent.applet.getImage(parent.applet.getDocumentBase(), "yakaliyorR.gif")	;
      else pic  = parent.applet.getImage(parent.applet.getDocumentBase(), "yakaliyorL.gif")	;

//        if (dx>2.70) dx=4.0;
//        else if (dx<-2.70) dx=-3.50;
      if (dy<-2.0) dy=-2.0;
      else if (dy>-1.50) dy=-1.50;


	if (!started) {this.start(); started=true;}
	else thread.resume();
    }

}

