import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.LocateRegistry;
import java.util.*;
import java.awt.Point;



//maintaines the master copy of user list and  update their user list 
//and public key list from the server
public class GameServer extends UnicastRemoteObject implements GameServerInterface
{
  //\\
    private Hashtable broadcastList = new Hashtable();
    private Hashtable broadcastPlayerList = new Hashtable();
    private MuhabereInterface GameClient;

  //\\
    public GameServer() throws RemoteException
    {
        super(); // invokes the constructor of java.rmi.server.UnicastRemoteObject,
                 // which export the remote object by listening for incoming calls
                 // to the remote object on an anonymous port.
    }
  //\\
    public static void main(String args[])
    {
      // a security manager needs to be running so that it can
      // guarantee that the classes loaded do not perform 
      // sensitive operatons. if not, no class loading for RMI
      // classes.
      int port=-1;  String host=null;
      try { port=Integer.parseInt(args[0]);  host =args[1];}
      catch  (Exception e) {}

      if (port==-1) port=2003;
      if (host==null) host="carver.npac.syr.edu";
      System.out.println("STARTING");
      System.setSecurityManager(new RMISecurityManager());
	
	  try
	  {
            LocateRegistry.createRegistry(port);
            System.out.println("registry ready");
            GameServer gameServer = new GameServer();
	    System.out.println("server ready, binding...");
            // bind the server to the registry
            Naming.rebind("//"+host+":"+port+"/GameServer",gameServer); 
            System.out.println("server bound to registery");
	  }
        catch (Exception e)
	  {
            System.out.println("GameServer error: " + e.getMessage());
            e.printStackTrace();
	    System.exit(0);
	  }
	System.out.println("SERVER READY at "+host+":"+port);
    }

  //\\
    // called by client. Updates  the newly joined client's user list
    public void register(MuhabereInterface client) throws RemoteException
    {
      System.out.println("Somebody connecting");   
      if (!broadcastList.isEmpty()) {
	try {
	  client.updatePlayerList(broadcastPlayerList);
	} catch (Exception e) {
	  System.out.println("GameServer error: at connect()\n " + e.getMessage());
	  e.printStackTrace();
	}
      }
     System.out.println("Somebody connected");   
    }

    public void send(String partner,String otype,int x,int y,int z) throws RemoteException
  {
      System.out.println("sending");
     MuhabereInterface p=((MuhabereInterface)broadcastList.get(partner));
     if (p!=null)
       p.adaptPartner(otype,x,y,z);
      System.out.println("sendin  g");
  }

  public MuhabereInterface es (String partner) throws RemoteException{
     MuhabereInterface p=((MuhabereInterface)broadcastList.get(partner));
     if (p!=null)
       return p;
     return null;
    
  }

  //\\
    //called when a client logins
  public void login(MuhabereInterface client,Object obj, String user) throws RemoteException 
  {
    if (!broadcastList.containsKey(user))
      {
	broadcastList.put(user, client);
	broadcastPlayerList.put(user, obj);
	updateClients(user+" joined to the game.");
      }

  }
  //\\
    //called when a client logins
  public void logout(String user) throws RemoteException 
  {
    if (broadcastList.containsKey(user))
      {
	broadcastList.remove(user);
	broadcastPlayerList.remove(user);
	updateClients(user+" leaves  the game.");
      }
    System.out.println(user+" leaves  the game.");
  }

  //\\
  public void logoff(String user) throws RemoteException
  {
    broadcastList.remove(user);
    broadcastPlayerList.remove(user);
    updateClients(user+" leaves the game.");
  }

  //\\
  public void   updateClients(String m) {
      String user="";
      boolean refresh=false;
    for (Enumeration e = broadcastList.keys(); e.hasMoreElements();) {
	try 
	  {user=(String) e.nextElement();
	    MuhabereInterface cl = (MuhabereInterface)broadcastList.get(user);
	    if (cl.updatePlayerList(broadcastPlayerList) ) 
		;
	    cl.displayMessage(m);
	  }
        catch (Exception ex)
	  {
	     broadcastList.remove(user);  broadcastPlayerList.remove(user);
	     refresh=true;
            System.out.println("GameServer error: broadcast() while " +m+"\n"+ ex.getMessage());
            //ex.printStackTrace();
	  }
      }
    if (refresh) refreshClients();
  }


  public  MuhabereInterface askPartnership(String player , String partner,String old) throws RemoteException {
      try {
    System.out.println("asking partnership *"+player+"("+old+")-->"+partner+"*");
    if (old!=null)
      ((MuhabereInterface)broadcastList.get(old)).deselect(player);
 System.out.println("gett player");
    MuhabereInterface pl=(MuhabereInterface) broadcastList.get(player);
 System.out.println("gett partner");
    MuhabereInterface pt=(MuhabereInterface) broadcastList.get(partner);
    if (pt==null)  System.out.println("NULL partner");
    if (pl==null)  System.out.println("NULL player");
 System.out.println("check availibility");
    if (  pt.available(player,pl)  ) {
	 System.out.println(partner+" available");
      return pt;
    } else  System.out.println(partner+" NOT NOT  available");
      } catch (Exception e) {  System.out.println("askPartnership"+e.getMessage());  e.printStackTrace(); }
    return null;
  }

  public void update(String user,Object obj) throws RemoteException {
      System.out.println(user+" updating");
	broadcastPlayerList.put(user, obj);
	refreshClients();
  }
  public void refreshClients() {
   for (Enumeration e = broadcastList.elements(); e.hasMoreElements();) {
	try {
	    MuhabereInterface cl = (MuhabereInterface) e.nextElement();
	    cl.updatePlayerList(broadcastPlayerList);
	  }
        catch (Exception ex)
	  {
            System.out.println("Refreshing");
            ex.printStackTrace();
	  }
      }
  }


}


